begin def


' Including C:\BIN\MOON\ffblk.h
' bundle definition for FINDFIRST, FINDNEXT, FEXIST functions

bundle FFBLK attr@, time%, date%, size&, name$[13] null
' Including C:\BIN\MOON\mrc.h
' MoonRock General Constant Definitions

' Termination constants

%EXIT_SUCCESS = 0
%EXIT_FAIL    = 1

' Including args.h
   sub getargs
   sub quoted( quoter$ )
   sub param
   sub other
   sub store( item$ )

   dim arg_v$[ 100 ]

   common cmd$, arg_c%
' Including parsefil.h
' Including nopath.h
   sub nopath( spec$ )
   common withoutpath$
   common justPath$

   sub parsefil( fspec$ )
   common PF_drv$
   common PF_path$
   common PF_nameExt$
   common PF_name$
   common PF_ext$
' Including getini.h
   ' support items for use by ini.moo

   common inivalue$, iItemCount%, opstatus%, getini_file$

   DIM aIniBuffer$[ 1000 ]

   sub getIni( pInifile$, pIniSect$, pIniItem$, pIniDefault$ )
   sub insection( pItemno%, pMaxitems%, pItem$, pDefault$ )
   sub loadini( pInifile$ )
' Including curscont.h
sub cursor_off

sub cursor_on

common am_com$
common am_ini$
common am_bat$
common am_sec$
common am_title$
common am_bkgnd$
common am_maxwidth%
common am_last$

sub show_menu
sub clear_arrays

Sub UpdateScreen
Sub Up
Sub Down
Sub DrawWindow1 (tx%, ty%, bx%, by%)
Sub UpdateFuzzy

%Down      = 80
%Up        = 72
%PageDown  = 81
%PageUp    = 73
%Home      = 71
%End       = 79
%Escape    = 27
%CR        = 13

dim plist$[100]
dim slist$[100]

strsegsize 64k

common ScPtr%, ElPtr%, ElementCnt%, ScreenBottom%, fuzzy$

begin code

   $outstream _tty_str_direct

   copyright$ = "Another Menu v0.1a (c) Copyright Bruce M. Axtens, 1996\n"
   fprint( 2, copyright$ )

ScPtr% = 0    ' top of screen
ElPtr% = 0    ' currently selected element

ScreenBottom% = scrlen - 6 - 4 'was without the -4
ElementCnt% = -1

   cls
   call getargs
   am_com$ = arg_v$[ 0 ]

   am_ini$ = am_com$
   call parsefil( am_ini$ )
   am_ini$ = PF_path$ + PF_name$ + ".INI"
   am_bat$ = PF_path$ + "MENU.BAT"

   if fexist( am_ini$, 7 ) = false then
      fprint( 1, am_ini$ + " not found.\n\n" )
      end
   endif

   call getini( am_ini$, "SETTINGS", "Background", "" )
   am_bkgnd$ = inivalue$


   am_sec$ = "MAIN"
   am_last$ = am_sec$
   am_title$ = "Another Menu"

   forever% = true
   while forever%
      call getini( am_ini$, am_sec$, "Type", "????" )
      if inivalue$ = "????" then
         fprint( 1, "Type not specified in section " + am_sec$ +".\n" )
         am_sec$ = am_last$
         goto bad
      endif
      am_typ$ = ucase( inivalue$ )
      call getini( am_ini$, am_sec$, "Title", "????" )
      if inivalue$ <> "????" then
        am_title$ = inivalue$
      endif
      select case am_typ$
         case "MENU"
            am_maxwidth% = 0
            call clear_arrays
            ElementCnt% = -1
            cnt% = ElementCnt% + 1
            cntr$ = str( cnt% )
            call getini( am_ini$, am_sec$, cntr$, "????" )
            while inivalue$ <> "????"
               ElementCnt% = ElementCnt% + 1
               compos% = cinstr( inivalue$,44 )
               if compos% > 0 then
                  compos% = compos%  - 1
                  sec$ = left( inivalue$, compos% )
                  compos% = compos% + 2
                  prm$ = mid( inivalue$, compos%, 255 )
                  prmlen% = len( prm$ )
                  if prmlen% > am_maxwidth% then
                     am_maxwidth% = prmlen%
                  endif
                  plist$[ ElementCnt% ] = prm$
                  slist$[ ElementCnt% ] = sec$
               else
                  fprint( 1, "Improperly formed line " + cntr$ + " in section " + am_sec$ + "\n" )
                  end
               endif
               cnt% = ElementCnt% + 1
               cntr$ = str( cnt% )
               call getini( am_ini$, am_sec$, cntr$, "????" )
            wend
            if ElementCnt% >= 0 then
               call show_menu
            else
               fprint( 1, "No menu item loaded.\n" )
               am_sec$ = am_last$
               goto bad
            endif
         case "CODE"
            am% = fcreate( am_bat$, archive )
            fprint( am%, "@echo off\n:loop\n" + am_com$ + "\n" )
            cnt% = 0
            eternity% = true
            while eternity%
               cntr$ = str( cnt% )
               call getini( am_ini$, am_sec$, cntr$, "????" )
               if inivalue$ = "????" then
                  exit while
               endif
               fprint( am%, inivalue$ + "\n" )
               cnt% = cnt% + 1
            wend
            fprint( am%, "goto loop\n" )
            fclose( am% )

         case "EXIT"
            am% = fcreate( am_bat$, archive )
            fprint( am%, "@echo off\n:loop\n" + am_com$ + "\n" )
            fclose( am% )

         case else
            fprint( 1, "Unknown type " + am_typ$ + "\n" )
            am_sec$ = am_last$
            goto bad

      end select
      if am_typ$ <> "MENU" then
         exit while
      endif
bad:
   wend
   end



' Including args.sub
sub getargs
   dquote$ = chr(34)
   squote$ = "'"

   me$ = mypath()
   me$ = ftruename( me$ )
   arg_v$[ 0 ] = me$

   arg_c% = 1

   'get command line
   cmd$ = cmdline

   'repeat until empty command line
   forever% = true
   while forever%
      cmd$ = ltrim( cmd$ )
      if cmd$ = "" then
         exit while
      endif

      'get first char of command line
      first$ = left( cmd$, 1 )

      select case first$
         case squote$
            call quoted( squote$ )
         case dquote$
            call quoted( dquote$ )
         case "/"
            call param
         case "-"
            call param
         case else
            call other
      end select
   wend
end sub
sub quoted( quoter$ )
   item$ = mid( cmd$, 2 )
   there% = sinstr( item$, quoter$ )
   if there% > 0 then
      there% = there% - 1
      item$ = left( item$, there% ) 'mid( item$, 1, there% )
      there% = there% + 3
      '... and remove this first item from the command line
      cmd$ = mid( cmd$, there% )
   else
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub param
   sep% = 32
   there% = cinstr( cmd$, sep% )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub other
   'otherwise next item in array is first item
   there% = cinstr( cmd$, 32 )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub store( item$ )
   arg_v$[ arg_c% ] = item$
   arg_c% = arg_c% + 1
end sub
' Including parsefil.sub
' Including nopath.sub
sub nopath( spec$ )
   i% = len( spec$ )
   found% = false
   forever% = true
   while forever%
#ifdef NOPATH
print "i%=" + i% + "\n"
#endif
      c$ = mid( spec$, i%, 1 )
      if c$ = "\\" then
         found% = true
         exit while
      endif
      i% = i% - 1
      if i% = 0 then
         exit while
      endif
   wend
   if found% = true then
      i% = i% + 1
      withoutpath$ = mid( spec$, i% )
      i% = i% - 1
      justPath$ = left( spec$, i% )
   else
      withoutpath$ = spec$
      justPath$ = ""
   endif

end sub




sub parsefil( fspec$ )
   c$ = mid( fspec$, 2, 1 )
   if c$ = ":" then
      PF_drv$ = left( fspec$, 1 )
   endif
   call nopath( fspec$ )
   PF_path$ = justPath$
   PF_nameExt$ = withoutpath$
   d% = cinstr( PF_nameExt$, 46 )
   if d% > 0 then
      d% = d% - 1
      PF_name$ = left( PF_nameExt$, d% )
      d% = d% + 1
      PF_ext$ = mid( PF_nameExt$, d% )
   else
      PF_name$ = PFnameExt$
      PF_ext$ = "."
   endif
end sub

' Including getini.sub
sub getIni( pInifile$, pIniSect$, pIniItem$, pIniDefault$ )
#ifdef GETINI
   fprint( 4, pInifile$ + " " + pIniSect$ + " " + pIniItem$ + " " + pIniDefault$ + "\n" )
#endif

   iniValue$ = pIniDefault$
   Section$ = "[" + pIniSect$ + "]"

   iniValue$ = pIniDefault$
#ifdef GETINI
   fprint( 4, getini_file$ + " " + pInifile$ + "\n" )
#endif
   if getini_file$ <> pInifile$ then
      call LoadIni( pInifile$ )
      getini_file$ = pInifile$
   endif
   IF iItemCount% > 0 then
      FOR Item% = 0 TO iItemCount%
         inputline$ = aIniBuffer$[ Item% ]
         inputline$ = ltrim( inputline$ )
         SectLen% = LEN( Section$ )
         Temp$ = LEFT( inputline$, SectLen% )
         IF Temp$ = Section$ then
            call InSection( Item%, iItemCount%, pIniItem$, pIniDefault$ )
            EXIT for
         ENDIF
      NEXT
   ENDIF
#ifdef GETINI
   fprint( 4, " " + iniValue$ + "\n" )
#endif
end sub

sub insection( pItemno%, pMaxitems%, pItem$, pDefault$ )
   Item$ = pItem$ + "="
   iniValue$ = pDefault$

   n% = pItemno% + 1
   FOR Item% = n% TO pMaxitems%
      inputline$ = aIniBuffer$[ Item% ]
      inputline$ = rTRIM( inputline$ )
      inputline$ = ltrim( inputline$ )
      LeftChar$ = LEFT( inputline$, 1 )
      IF LeftChar$ = "[" then
         EXIT for
      endif
      ItemLen% = Len( Item$ )
      Temp$ = LEFT( inputline$, ItemLen% )
      IF Temp$ = Item$ then
         ItemLen% = ItemLen% + 1
         iniValue$ = mid( inputline$, ItemLen% )
         EXIT for
      ENDIF
   NEXT
end sub

sub loadini( pInifile$ )
    iItemCount% = 0
    if fexist( pIniFile$, 7 ) = false then
        exit sub
    endif
    iniHandle% = fopen( pInifile$, readonly )
    forever% = true
    while forever%
        inputline$ = space(127)
        finput(iniHandle%, inputline$)
        if feof( iniHandle% ) = true then
            exit while
        endif
        inputline$ = rTRIM( inputline$ )
        aIniBuffer$[ iItemCount% ] = inputline$
        iItemCount% = iItemCount% + 1
    wend
    fclose( iniHandle% )
end sub


Sub DrawWindow1 (tx%, ty%, bx%, by%)
' top left, bottom right
mcursor tx%, ty%
width% = bx% - tx% - 2
print "" + repstr("", width%) + "\n"
t% = by% - ty% - 2
ty% = ty% + 1
for i% = 1 to t%
  mcursor tx%, ty%
  ty% = ty% + 1
  print "" + space(width%) + " "
next
mcursor tx%, ty%
print "" + repstr("", width%) + " "
ty% = ty% + 1
tx% = tx% + 1
Width% = Width% + 2
mcursor tx%, ty%
print space(width%)
end sub

Sub UpdateScreen
t% = ScPtr% + ScreenBottom%
yp% = 6 '6 was 2
for i% = ScPtr% to t%
  mcursor 4, yp%
  yp% = yp% + 1
  colour 7, 0
  if i% = ElPtr% then
    colour 14, 1
    print plist$[i%]
    c% = len(plist$[i%])
    c% = am_maxwidth% - c%  ' 12 - c%
    print space(c%)
    colour 7, 0
    print "\n"
  else
    c% = len(plist$[i%])
    c% = am_maxwidth% - c% ' 12 - c%
    print plist$[i%] + space(c%) + "\n"
  endif
  if i% > ElementCnt% then exit for
next
end sub


Sub Down
if ElPtr% < ElementCnt% then
  t% = ElPtr% - ScPtr%
  if t% = ScreenBottom% then ScPtr% = ScPtr% + 1
  ElPtr% = ElPtr% + 1
endif
end sub


Sub Up
if ElPtr% > 0 then
  ElPtr% = ElPtr% - 1
  t% = ElPtr% - ScPtr%
  if t% = -1 then ScPtr% = ScPtr% -1
endif
end sub


Sub UpdateFuzzy
for i% = 0 to ElementCnt%
  fuz$ = ucase( fuzzy$ )
  fuzlen% = len( fuz$ )
  prm$ = plist$[i%]
  prm$ = ucase( prm$ )
  prm$ = left( prm$, fuzlen% )
  if prm$ = fuz$ then
    ElPtr% = i%
    ScPtr% = i% - ScreenBottom%
    if ScPtr% < 0 then ScPtr% = 0
       exit for
  endif
next
mcursor 3, 5 '5 was 1
colour 14, 4
t$ = space(12) + fuzzy$
t% = len(t$) - 12
print mid(t$, t%) + " "
end sub

' Including curscont.sub
sub cursor_off
@ mov ah, 01h
@ mov cx, 2000h
@ int 10h
end sub

sub cursor_on
@ mov ah, 01h
@ mov cx, 0607h
@ int 10h
end sub

sub show_menu
   'cls
   ElPtr% = 0
   call cursor_off
   colour 3, 1
   t% = scrlen
   for i% = 0 to t%
     mcursor 0, i%
     print repstr(am_bkgnd$, 79)
   next
   colour 10, 0
   t% = scrlen - 2
   if am_maxwidth% > 12 then
      ww% = am_maxwidth% + 6
   else
      ww% = 18
   endif
   call DrawWindow1 (2, 5, ww%, t%) '5 was 1
   colour 15, 4
   mcursor 3, 5 '5 was 1
   print space(14)
   colour ?, 0

'   colour 14
'   t% = ScreenBottom% shr 1 - 1
'   t2% = t% + 4
'   call DrawWindow1(25, t%, 68, t2%)
'   t% = t% + 1
'   mcursor 26, t%
'   colour 10, 1
'   print am_title$
'   t% = t% + 1
'   mcursor 26, t%
'   print "-- Press ESC to exit, Enter to select --"
'   colour ?,0

   colour 14
   t% = 0 'was ScreenBottom% shr 1 - 1
   t2% = t% + 4
   call DrawWindow1(1, t%, 43, t2%)
   t% = t% + 1
   mcursor 2, t%
   colour 10, 1
   print am_title$
   t% = t% + 1
   mcursor 2, t%
   print "-- Press ESC to exit, Enter to select --"
   colour ?,0

   fuzzy$ = ""

   call UpdateScreen

   exitnow% = FALSE
   escaped% = FALSE

   while exitnow% = FALSE
     k% = inkey
     select case k%
       case %CR
         exitnow% = TRUE
       case -1               ' no key pressed
         timeslice
       case 0                ' extended key pressed
         ekey% = inkey
         select case ekey%
           case %Down
             call Down
             call UpdateScreen
           case %Up
             call Up
             call UpdateScreen
           case %End
             ElPtr% = ElementCnt%
             ScPtr% = ElementCnt% - ScreenBottom%
             if ScPtr% < 0 then ScPtr% = 0
             call UpdateScreen
           case %Home
             ElPtr% = 0
             ScPtr% = 0
             call UpdateScreen
           case %PageDown
             for z% = 1 to ScreenBottom%
               call Down
             next
             call UpdateScreen
           case %PageUp
             for z% = 1 to ScreenBottom%
               call Up
             next
             call UpdateScreen
         end select
       case %Escape
         exitnow% = TRUE
         escaped% = TRUE
       case else
         if k% > 32 then
           if k% < 127 then
             if len(fuzzy$) < 12 then
               c$ = chr(k%)
               fuzzy$ = fuzzy$ + c$
               call UpdateFuzzy
               call UpdateScreen
             endif
           endif
         endif
         if k% = 8 then
           if len(fuzzy$) > 0 then
             l% = len(fuzzy$) - 1
             fuzzy$ = left(fuzzy$, l%)
             call UpdateFuzzy
             if fuzzy$ = "" then
               ElPtr% = 0
               ScPtr% = 0
             endif
             call UpdateScreen
           endif
         endif
     end select
   wend

   done:
   colour 15
   cls

   call cursor_on
   if escaped% = FALSE then
      am_last$ = am_sec$
      am_sec$ = slist$[ ElPtr% ]
   else
      am_sec$ = am_last$
   endif

end sub

sub clear_arrays
   for i% = 0 to 100
      plist$[i%] = ""
      slist$[i%] = ""
   next
end sub

